from binascii import hexlify
import iscc_sdk as idk
import jcs
from data_url import DataURL
import os
import base64
import random
import pandas as pd
from scipy.spatial.distance import hamming
from openlocationcode import openlocationcode as olc
import math

"""

CREATE NODES ID BY CONCATENING SMALLER R-STRING ID GENERATED BY EVERY CHARACTER IN THE ISCC CODE

    TEST TO DEMONSTRATE DISTANCES BETWEEN SIMILAR CONTENT

"""

def calcISCC(path, title, metas):

    meta_serialized = jcs.canonicalize(metas)
    

    du_obj = DataURL.from_data('application/json',base64_encode=True, data=meta_serialized)

    ic_meta = idk.IsccMeta(name=title,description="description",meta=du_obj.url) 
    iscc_meta = idk.embed_metadata(path,ic_meta)

    iscc_meta = idk.code_meta(iscc_meta).dict()

    iscc_content = idk.code_content(path).dict()
    
    # base64_metas = iscc_meta['meta'][iscc_meta['meta'].index(',')+1:]
    # 
    # decoded_metas = base64.b64decode(base64_metas).decode('ascii')
    # print("base64 decoded metadata: "+decoded_metas)
    # print()
    
    return iscc_meta['iscc'][5:], iscc_content['iscc'][5:]


# Find the node into the Hypercube where assign the file
def calc_node_id(iscc_meta, iscc_content, r, g):

    iscc_decomposed_meta = []
    iscc_decomposed_content = []
    tmp_str_meta = ""
    tmp_str_content = ""

    for i in range(0,len(iscc_meta)): # meta and content have the same length

        # create the decomposed iscc string to calculate the hash and then the node ID 
        tmp_str_meta += iscc_meta[i]  
        tmp_str_content += iscc_content[i]

        if (i+1) % g == 0:
            iscc_decomposed_meta.append(tmp_str_meta)
            iscc_decomposed_content.append(tmp_str_content)
            tmp_str_meta = ""
            tmp_str_content = ""

    final_r = []

    for i in range(0, len(iscc_decomposed_meta)): # meta and content have the same length

        deco_hex_meta = hexlify(iscc_decomposed_meta[i].encode()).decode()
        deco_hex_content = hexlify(iscc_decomposed_content[i].encode()).decode()
        val_int_meta = int(deco_hex_meta,16) # base 16 for hexa string
        val_int_content = int(deco_hex_content,16) # base 16 for hexa string
        mod_meta = val_int_meta % r
        mod_content = val_int_content % r
        r_string_chunk = [0 for i in range(0,r)]
        #r_string_chunk[mod_meta] = 1
        r_string_chunk[mod_content] = 1 # turn on only bits from Meta-Code
        final_r.append(r_string_chunk)

    final_r_ = []
    for el in final_r:
        final_r_.extend(el)

    return final_r_


# # Create a csv file for every folder with simil images inside and save them into the "csvs" folder 
def create_csv(rootdir, dir_csvs, r, g):

    for root, subFolders, files in os.walk(rootdir):

        for dir in subFolders:
            
            i = 0
            img_cls_dir = os.path.join(rootdir, dir)
            dir_df = pd.DataFrame(columns = ['Img-Name','Meta', 'Content',  'Final-R'])

            latlong = {
                "lat": round(random.uniform(-190,190), 6),
                "long": round(random.uniform(-190,190), 6),
            }    

            _olc = olc.encode(latlong['lat'], latlong['long'], 8)
            
            img_cls_meta = {
                "@type":"Places",
                "olc": _olc
            }

            for file in os.listdir(img_cls_dir):

                ic_meta, ic_content = calcISCC(os.path.join(img_cls_dir, file), file, img_cls_meta)

                # print("R_string per il file: "+ file)
                final_r = calc_node_id(ic_meta, ic_content, r, g)
                # print(final_r)

                row = [str(file),str(ic_meta),str(ic_content),str(final_r)]
                dir_df.loc[i] = row
                i+=1

            
            dir_df.to_csv(dir_csvs+'/'+str(dir)+'.csv')



# # Calc hamming distance between codes and create distance matrices
def code_hamming_distance(csvs, hamming_csvs):

    for file in os.listdir(csvs):

        if "hamming" not in str(file):
            hamming_file = str(file)[:-4] + "_hamming.csv"

            df_codes = pd.read_csv(os.path.join(csvs, file))
            df_codes = df_codes.iloc[:,1:]
            idx_h_df = list(df_codes['Img-Name'])
            idx_h_df.insert(0,'Type')
            cols = idx_h_df[1:]
            df_codes = df_codes.set_index('Img-Name')
            #print(df_codes)

            concat_df = pd.DataFrame()

            for col in df_codes.keys():

                sep = [col for i in range(0,len(cols))]

                h_df = pd.DataFrame(columns=cols, index=idx_h_df)
                h_df.loc['Type'] = sep

                for idx, row in df_codes.iterrows():
                    img = idx
                    str1 = str(df_codes.loc[img,col]).replace(' ','').replace('[','').replace(']','').replace(',','')

                    for idx, row in df_codes.iterrows():
                        
                        str2=str(df_codes.loc[idx,col]).replace(' ','').replace('[','').replace(']','').replace(',','')
                        print(str1, "    ", str2)
                        # hamming(x, y) * len(x) -> * len(x) because hamming() returns the percentage of elements that differs
                        h_dist = hamming(list(str1),list(str2)) * len(list(str1))
                        print(h_dist)
                        h_df.loc[img,idx] = round(h_dist)

                concat_df = pd.concat([concat_df,h_df], ignore_index=False)

            concat_df.to_csv(os.path.join(hamming_csvs, hamming_file))



def main_id_concat_gen(g):

    rootdir = '../../../photos'
    dir_csvs = "../../results/iscc/csvs"
    r = 16

    create_csv(rootdir,dir_csvs,r,g)
    code_hamming_distance(dir_csvs, dir_csvs)


    



        








